


/* Rekurzivni funkce spocita a vrati hodnotu x^n (n je prirozene cislo). */
double mocninaRek(double x, int n)
{
	if (n < 0)
		return mocninaRek(1 / x, -n);
	if (n == 0)
		return 1;
	return x * mocninaRek(x, n - 1);
}

/* Rekurzivni funkce spocita a vrati n-ty clen Fibonacciho posloupnosti */
int fibonacciRek(int n)
{
	if (n <= 0)
		return 0;
	if (n == 1)
		return 1;
	return fibonacciRek(n - 1) + fibonacciRek(n - 2);
}

/* Nerekurzivni funkce spocita a vrati n-ty clen Fibonacciho posloupnosti */
int fibonacci(int n)
{
	if (n <= 0)
		return 0;
	if (n == 1)
		return 1;
	int a = 0, b = 1, p;
	for (int i = 2; i <= n; i++)
	{
		p = a + b;
		a = b;
		b = p;
	}
	return b;
}

/* Funkce spocita a vrati hodnotu x^n (n je prirozene cislo). */
double mocnina(double x, int n)
{
	if (n < 0)
	{
		x = 1 / x;
		n = -n;
	}
	double y = 1;
	for (int i = 1; i <= n; i++)
		y *= x;
	return y;
}

/*Funkce spocte odhad eulerova cisla jako hodnotu (1 + 1/n)^n.*/
double euler(int n)
{
	double x = (1 + 1.0 / n); 	// double x = 1 + (double)1 / n;
	return mocnina(x, n);
}

/* Funkce vrati nejmensi n takove, ze x <= 2^n. */
int najdi(double x)
{
	int n = 0;
	while (x > mocnina(2, n))
		n++;
	return n;
}

/* Funkce vrati true, prave kdyz je n prvocislo */
bool jePrvocislo(int n)
{
	if (n <= 0)
		return false;
	for (int i = 2; i < n; i++) // i <= sqrt(n)
	{
		if (n % i == 0)
			return false;
	}
	return true;
}